/**
 ** qarmPA10.h
 **
 ** 
 **
 ** Auteur: Daniel SIDOBRE
 ** Date: octobre 2004
 ** 
 **
 **/
#ifndef QARMPA10_H
#define QARMPA10_H

#include <stdlib.h>

#include "pa.h"
/* #include "pacmd.h" */
/* #include "pactl.h" */
#include "paerr.h"
/* #include "pammc.h" */
/* #include "papci.h" */

#include "../qarmStruct.h"

/* palib can control several arm, each motion control board and arm 
 *   as a number. For one arm we use 0 and PA10_ARM_NUMBER.
 */
#define PA10_ARM_NUMBER 0


#define PA10_ERROR_PRINT(S, MESS)					\
  do {									\
    if (S != ERR_OK) {						        \
      fprintf(stderr, "%s:%d: Pb " #MESS "\n  PALib erreur :%s\n",	\
	      __FILE__, __LINE__, pa10ErrorGetString(S));		\
    }									\
  } while (0)

#define PA10_ERROR_RETURN(S, MESS, RETURNVALUE)                         \
  do {									\
    if (S != ERR_OK) {							\
      *report = S_qarm_PALIB_ERROR;					\
      fprintf(stderr, "%s:%d: Pb " #MESS "\n  PALib erreur :%s\n",	\
	      __FILE__, __LINE__, pa10ErrorGetString(S));		\
      return RETURNVALUE;						\
    }									\
  } while (0)


#include "Proto_paLibError.h"
#include "Proto_qarmCntrlTaskCodels.h"
#include "Proto_qarmFunctionPA10.h"
#include "Proto_qarmMainTaskCodels.h"
#include "Proto_qarmTrackTaskCodels.h"


#endif
