/**
 ** qarmTrackTaskCodels.c
 **
 ** Codels called by execution task qarmTrackTask
 **
 ** Author: 
 ** Date: 
 **
 **/

#ifdef VXWORKS
# include <vxWorks.h>
#else
# include <portLib.h>
#endif
#include <stdio.h>
#include "server/qarmHeader.h"

#include "gbGENOM.h"
#include "qarmPA10.h"


static POSTER_ID qarm_poster_vq = NULL;
int qarm_poster_vq_counter = -1;
int qarm_poster_vq_nb;

/*------------------------------------------------------------------------
 * TrackQ
 *
 * Description: 
 *
 * Reports:      OK
 *              S_qarm_POSTER_NOT_FOUND
 *              S_qarm_BAD_REF
 *              S_qarm_CMD_STOP_TRACK
 */

/* qarmTrackQStart  -  codel START of TrackQ
   Returns:  START EXEC END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
qarmTrackQStart(QARM_STRING_128 *(posterName), int *report)
{
  /* ... add your code here ... */
  return ETHER;
}

/* qarmTrackQExec  -  codel EXEC of TrackQ
   Returns:  EXEC END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
qarmTrackQExec(QARM_STRING_128 *(posterName), int *report)
{
  /* ... add your code here ... */
  return ETHER;
}

/* qarmTrackQEnd  -  codel END of TrackQ
   Returns:  END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
qarmTrackQEnd(QARM_STRING_128 *(posterName), int *report)
{
  /* ... add your code here ... */
  return ETHER;
}

/* qarmTrackQInter  -  codel INTER of TrackQ
   Returns:  INTER ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
qarmTrackQInter(QARM_STRING_128 *(posterName), int *report)
{
  /* ... add your code here ... */
  return ETHER;
}

/*------------------------------------------------------------------------
 * TrackVq
 *
 * Description: 
 *
 * Reports:      OK
 *              S_qarm_POSTER_NAME_TOO_LONG
 *              S_qarm_NOT_IN_MANUAL_MODE
 *              S_qarm_POSTER_NOT_FOUND
 *              S_qarm_BAD_REF
 *              S_qarm_CMD_STOP_TRACK
 *              S_qarm_COUNTER_MAX
 */

/* qarmTrackVqStart  -  codel START of TrackVq
   Returns:  START EXEC END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
qarmTrackVqStart(QARM_STRING_128 *(posterName), int *report)
{
  STATUS status;

  if (posterFind(posterName->string, &qarm_poster_vq)  == ERROR) {
    QARM_ERROR_PRINT(ERROR, "Pb qarmTrackVqStart");
    *report = S_qarm_POSTER_NOT_FOUND;
    return ETHER;
  }
  if (SDI_F->state.mode == QARM_STATE_MANUAL) {
    SDI_F->state.mode = QARM_STATE_TRACK;
  } else {
    *report = S_qarm_NOT_IN_MANUAL_MODE;
    if (SDI_F->state.mode == QARM_STATE_TRACK) 
      printf("qarmTrackVqStart normaly genom prohibit QARM_STATE_TRACK state\n"); 
    printf("SDI_F->state.mode= %d\n", SDI_F->state.mode);
    QARM_ERROR_PRINT(ERROR, "Pb qarmTrackVqStart");
    return ETHER;
  }
  status = pa_set_tim(PA10_ARM_NUMBER, SDI_F->iarm.timeOutPCICard);
  if (status != ERR_OK) {
    QARM_ERROR_STOP(status, "qarmMainTaskInit: pa_set_tim");
    *report = S_qarm_PALIB_ERROR;
    return ETHER;
  }
  /* VM_ONE is q axis velocity mode */
  status = pa_mod_vel(PA10_ARM_NUMBER, VM_ONE, ALLAXIS);
  if (status != ERR_OK) {
    QARM_ERROR_STOP(status, "Pb qarmTrackVqStart");
    *report = S_qarm_PALIB_ERROR;
    return ETHER;
  }
  qarm_poster_vq_nb = 0;
  return EXEC;
}

/* qarmTrackVqExec  -  codel EXEC of TrackVq
   Returns:  EXEC END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
qarmTrackVqExec(QARM_STRING_128 *(posterName), int *report)
{
  QARM_VELOCYTY_TRACK_STR velocity_poster;

  if (SDI_F->state.mode != QARM_STATE_TRACK)
    return END;
  if (qarm_poster_vq == NULL) {
    QARM_ERROR_STOP(ERROR, "Pb qarmTrackVqExec");
    *report = S_qarm_POSTER_NOT_FOUND;
    return ETHER;
  }
  *report = 
    qarmQARM_VELOCYTY_TRACK_STRPosterRead(qarm_poster_vq, &velocity_poster);
  if (*report != OK) {
    QARM_ERROR_STOP(ERROR, "Pb qarmTrackVqExec");
    return ETHER;
  }
  if (qarm_poster_vq_counter != velocity_poster.counter) {
    qarm_poster_vq_counter = velocity_poster.counter;
    qarm_poster_vq_nb = 0;
  } else {
    if (qarm_poster_vq_nb > velocity_poster.counterMax) {
      QARM_ERROR_STOP(ERROR, "Pb counterMax is reached");
      *report = S_qarm_COUNTER_MAX;
      return ETHER;
    }
    qarm_poster_vq_nb++;
  }
  SDI_F->vqConsigne.q1 = velocity_poster.qVelocityC.q1;
  SDI_F->vqConsigne.q2 = velocity_poster.qVelocityC.q2;
  SDI_F->vqConsigne.q3 = velocity_poster.qVelocityC.q3;
  SDI_F->vqConsigne.q4 = velocity_poster.qVelocityC.q4;
  SDI_F->vqConsigne.q5 = velocity_poster.qVelocityC.q5;
  SDI_F->vqConsigne.q6 = velocity_poster.qVelocityC.q6;
  return EXEC;
}

/* qarmTrackVqEnd  -  codel END of TrackVq
   Returns:  END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
qarmTrackVqEnd(QARM_STRING_128 *(posterName), int *report)
{
  qarmStopSoft();
  /*  qarm_poster_vq = NULL; ???*/
  SDI_F->vqConsigne.q1 = 0;
  SDI_F->vqConsigne.q2 = 0;
  SDI_F->vqConsigne.q3 = 0;
  SDI_F->vqConsigne.q4 = 0;
  SDI_F->vqConsigne.q5 = 0;
  SDI_F->vqConsigne.q6 = 0;
  return ETHER;
}

/* qarmTrackVqInter  -  codel INTER of TrackVq
   Returns:  INTER ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
qarmTrackVqInter(QARM_STRING_128 *(posterName), int *report)
{
  qarmStopSoft();
  /*  qarm_poster_vq = NULL; ???*/
  SDI_F->vqConsigne.q1 = 0;
  SDI_F->vqConsigne.q2 = 0;
  SDI_F->vqConsigne.q3 = 0;
  SDI_F->vqConsigne.q4 = 0;
  SDI_F->vqConsigne.q5 = 0;
  SDI_F->vqConsigne.q6 = 0;
  return ETHER;
}

/*------------------------------------------------------------------------
 * TrackQVq
 *
 * Description: 
 *
 * Reports:      OK
 *              S_qarm_POSTER_NOT_FOUND
 *              S_qarm_BAD_REF
 *              S_qarm_CMD_STOP_TRACK
 */

/* qarmTrackQVqStart  -  codel START of TrackQVq
   Returns:  START EXEC END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
qarmTrackQVqStart(QARM_STRING_128 *(posterName), int *report)
{
  /* ... add your code here ... */
  return ETHER;
}

/* qarmTrackQVqExec  -  codel EXEC of TrackQVq
   Returns:  EXEC END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
qarmTrackQVqExec(QARM_STRING_128 *(posterName), int *report)
{
  /* ... add your code here ... */
  return ETHER;
}

/* qarmTrackQVqEnd  -  codel END of TrackQVq
   Returns:  END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
qarmTrackQVqEnd(QARM_STRING_128 *(posterName), int *report)
{
  /* ... add your code here ... */
  return ETHER;
}

/* qarmTrackQVqInter  -  codel INTER of TrackQVq
   Returns:  INTER ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
qarmTrackQVqInter(QARM_STRING_128 *(posterName), int *report)
{
  /* ... add your code here ... */
  return ETHER;
}


